      SUBROUTINE SF74R(X,N1,EPS,S,T,T1)
         INTEGER N1
         REAL EPS,T,T1,X
         LOGICAL S
         DIMENSION T(N1),T1(N1)
         INTEGER D,IP,IP1,IP2,IZ3,IZ4,IZ6,K,K1,K2,M,N,P
         REAL ABS,C,ERR,EXP,FLOAT,R0,R1,R2,SUM,Y,Z,Z0,Z1,Z2,Z5,Z7
         LOGICAL F
         DATA SYS053/3.4E38/,SYS055/1.2E-38/
       N = N1 - 1
       IF (X) 30, 10, 30
   10  CONTINUE
       T(1) = 1.0
       DO 20 P = 2, N1
          T(P) = 0.0
   20  CONTINUE
       GO TO 320
   30  CONTINUE
       Z0 = EXP(-X) - SYS055
       IF (Z0) 40, 50, 50
   40  CONTINUE
       S = .FALSE.
   50  CONTINUE
       IF (S) GO TO 60
          C = 1.0
          GO TO 70
   60  CONTINUE
       C = EXP(-X)
   70  CONTINUE
       Y = ABS(X)
       Z1 = Y - 1.0
       IF (Z1) 80, 80, 90
   80  CONTINUE
       M = 10
       D = 3
       GO TO 120
   90  CONTINUE
       Z2 = Y - 10.0
       IF (Z2) 100, 100, 110
  100  CONTINUE
       M = 10 + 1.5*Y
       D = 3 + 0.5*Y
       GO TO 120
  110  CONTINUE
       M = 25 + 0.5*Y
       D = 0.25*Y + 100./Y
  120  CONTINUE
       IZ3 = M - N
       IF (IZ3) 130, 130, 140
  130  CONTINUE
       M = N + D
  140  CONTINUE
       F = .FALSE.
  150  CONTINUE
       SUM = 0.0
       R0 = 0.0
       R1 = 1.0
       Z = SYS053/4./M*Y
       DO 250 IP1 = 1, M
          IP = M - IP1 + 1
          IP2 = IP - 1
          P = FLOAT(IP)
          IZ4 = N + 1 - IP
          IF (IZ4) 160, 170, 170
  160     CONTINUE
          R2 = 2.0*P/X*R1 + R0
          T(N1) = R2
          GO TO 180
  170     CONTINUE
          R2 = 2.0*P/X*R1 + R0
          T(IP) = R2
  180     CONTINUE
          Z5 = Z - ABS(R2)
          IF (Z5) 190, 210, 210
  190     CONTINUE
          R1 = R1/Z
          R2 = R2/Z
          SUM = SUM/Z
          DO 200 K1 = IP2, N
             K = IP2 + N - K1
             K2 = K + 1
             T(K2) = T(K2)/Z
  200     CONTINUE
  210     CONTINUE
          IZ6 = IP - 1
          IF (IZ6) 230, 220, 230
  220     CONTINUE
          SUM = SUM + R2
          GO TO 240
  230     CONTINUE
          SUM = SUM + 2.*R2
  240     CONTINUE
          R0 = R1
          R1 = R2
  250  CONTINUE
       SUM = SUM*C
       DO 260 IP1 = 1, N1
          T(IP1) = T(IP1)/SUM
  260  CONTINUE
       IF (F) GO TO 270
          GO TO 300
  270  CONTINUE
       ERR = ABS(T(N1) - T1(N1))
       Z7 = ERR - EPS*ABS(T(N1))
       IF (Z7) 280, 280, 290
  280  CONTINUE
       GO TO 320
  290  CONTINUE
  300  CONTINUE
       F = .TRUE.
       DO 310 IP = 1, N1
          T1(IP) = T(IP)
  310  CONTINUE
       M = M + D
       GO TO 150
  320  CONTINUE
       RETURN
      END
